-- Design.ex
-- Beginning of a form designer for Win32Lib


include dos32lib.e
without warning

-------------------------------------------------------------------------------
-- define the controls
constant         
Design      = create( Window, "Design Window", 0, 80, 10, 300, 300, 0),                                        
Controls    = create( Window, "Controls", Design, 10, 10, 63, 193, 
                    or_all( {WS_POPUP, WS_CAPTION} ) ),
    ThePointer      = create( Bitmap, "", Controls, 03, 03,  28, 28, 0 ),
    ThePicture      = create( Bitmap, "", Controls, 30, 03,  28, 28, 0 ),
    TheStaticText   = create( Bitmap, "", Controls, 03, 30,  28, 28, 0 ),
    TheEditText     = create( Bitmap, "", Controls, 30, 30,  28, 28, 0 ),
    TheFrame        = create( Bitmap, "", Controls, 03, 57,  28, 28, 0 ),
    ThePushButton   = create( Bitmap, "", Controls, 30, 57,  28, 28, 0 ),
    TheCheckBox     = create( Bitmap, "", Controls, 03, 84,  28, 28, 0 ),
    TheRadioButton  = create( Bitmap, "", Controls, 30, 84,  28, 28, 0 ),
    TheComboBox     = create( Bitmap, "", Controls, 03, 111, 28, 28, 0 ),
    TheList         = create( Bitmap, "", Controls, 30, 111, 28, 28, 0 ),
    TheHScroll      = create( Bitmap, "", Controls, 03, 138, 28, 28, 0 ),
    TheVScroll      = create( Bitmap, "", Controls, 30, 138, 28, 28, 0 ),

AttribBox   = create( Window, "Attributes", Design, Default, Default, 100, 100, 
                    or_all( {WS_DLGFRAME, WS_CAPTION} ) ),
    Ok      = create( PushButton, "OK",     AttribBox, 10, 10, 40, 50, 0 )
        
-------------------------------------------------------------------------------
-- graphics associated with various controls
constant
    PointerPic = {
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x         x                x",
    "x         xx               x",
    "x         xxx              x",
    "x         xxxx             x",
    "x         xxxxx            x",
    "x         xxxxxx           x",
    "x         xxxxxxx          x",
    "x         xxxxxxxx         x",
    "x         xxxxx            x",
    "x         xx xx            x",
    "x         x   xx           x",
    "x             xx           x",
    "x              xx          x",
    "x              xx          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx"},

    StaticTextPic = {    
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x            x             x",
    "x           xxx            x",
    "x           xxx            x",
    "x          x xxx           x",
    "x          x xxx           x",
    "x         x   xxx          x",
    "x         x   xxx          x",
    "x        x     xxx         x",
    "x        xxxxxxxxx         x",
    "x       x       xxx        x",
    "x       x       xxx        x",
    "x      x         xxx       x",
    "x     xx         xxxx      x",
    "x    xxxx       xxxxxx     x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx"},

    FramePic = {    
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx",
    "x                          x",
    "x                          x",
    "x                          x",
    "x      x x x x xxx         x",
    "x       x  x x  x          x",
    "x   xx  x   x  x   xxxx    x",
    "x   x  x x  x  xxx    x    x",
    "x   x                 x    x",
    "x   x                 x    x",
    "x   x                 x    x",
    "x   x                 x    x",
    "x   x                 x    x",
    "x   x                 x    x",
    "x   x                 x    x",
    "x   x                 x    x",
    "x   x                 x    x",
    "x   x                 x    x",
    "x   x                 x    x",
    "x   x                 x    x",
    "x   x                 x    x",
    "x   x                 x    x",
    "x   xxxxxxxxxxxxxxxxxxx    x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx"},

    CheckBoxPic = {    
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x      xxxxxxxxxxxxx       x",
    "x      xx         xx       x",
    "x      x x       x x       x",
    "x      x  x     x  x       x",
    "x      x   x   x   x       x",
    "x      x    x x    x       x",
    "x      x     x     x       x",
    "x      x    x x    x       x",
    "x      x   x   x   x       x",
    "x      x  x     x  x       x",
    "x      x x       x x       x",
    "x      xx         xx       x",
    "x      xxxxxxxxxxxxx       x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx"},

    ComboBoxPic = {    
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x   xxxxxxxxxxxxxxxxxxxx   x",
    "x   x            xx   xx   x",
    "x   x            xxx xxx   x",
    "x   x            xxxxxxx   x",
    "x   xxxxxxxxxxxxxxxxxxxx   x",
    "x    x           x     x   x",
    "x    x           x  x  x   x",
    "x    x xxxxxxx   x xxx x   x",
    "x    x           x     x   x",
    "x    x           x     x   x",
    "x    x xxxxxxxxx xxxxxxx   x",
    "x    x           x     x   x",
    "x    x           x     x   x",
    "x    x xxxxxxxx  x xxx x   x",
    "x    x           x  x  x   x",
    "x    x           x     x   x",
    "x    xxxxxxxxxxxxxxxxxxx   x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx"},

    HScrollPic = {    
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x  xxxxxxxxxxxxxxxxxxxxx   x",
    "x  x         x         x   x",
    "x  x         x         x   x",
    "x  x    x    x    x    x   x",
    "x  x   xxxx  x  xxxx   x   x",
    "x  x  xxxxx  x  xxxxx  x   x",
    "x  x   xxxx  x  xxxx   x   x",
    "x  x    x    x    x    x   x",
    "x  x         x         x   x",
    "x  x         x         x   x",
    "x  xxxxxxxxxxxxxxxxxxxxx   x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx"},

    TimerPic = {    
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx",
    "x                          x",
    "x                          x",
    "x                          x",
    "x           xxxxx          x",
    "x          x x x x         x",
    "x           xxxxx          x",
    "x            x x           x",
    "x       xx  xx xx  xx      x",
    "x      x xxx     xxx x     x",
    "x      xxx  xxxxx  xxx     x",
    "x       x xx     xx x      x",
    "x      x x    x    x x     x",
    "x      x x x     x x x     x",
    "x     x x       x   x x    x",
    "x     x x      x    x x    x",
    "x     x x x   x   x x x    x",
    "x     x x           x x    x",
    "x     x x           x x    x",
    "x      x x x     x x x     x",
    "x      x x    x    x x     x",
    "x       x xx     xx x      x",
    "x        x  xxxxx  x       x",
    "x         xx     xx        x",
    "x           xxxxx          x",
    "x                          x",
    "x                          x",
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx"},

    PicturePic = {    
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x   xxxxxxxxxxxxxxxxxxxx   x",
    "x   x                  x   x",
    "x   x    x       xxx   x   x",
    "x   x   x x     x   x  x   x",
    "x   x  xx x     x   x  x   x",
    "x   x x x x     x   x  x   x",
    "x   x x x xxx    xxx   x   x",
    "x   x x x xx x         x   x",
    "x   x  x  xx x         x   x",
    "x   xxxxx x xxxxxxxxxxxx   x",
    "x   x   x  x           x   x",
    "x   x   x x  xx  xx    x   x",
    "x   x   x x x  x       x   x",
    "x   x  xxxx xxxxx   xx x   x",
    "x   x xxxx             x   x",
    "x   xxxxxxxxxxxxxxxxxxxx   x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",    
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx"},

    EditTextPic = {    
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x   xxxxxxxxxxxxxxxxxxxx   x",
    "x   x                  x   x",
    "x   x                x x   x",
    "x   x        xx      x x   x",
    "x   x        xx      x x   x",
    "x   x        xx      x x   x",
    "x   x  xxxx  xxxxx   x x   x",
    "x   x xx  xx xx  xx  x x   x",
    "x   x   xxxx xx  xx  x x   x",
    "x   x  xx xx xx  xx  x x   x",
    "x   x xx  xx xx  xx  x x   x",
    "x   x xx  xx xx  xx  x x   x",
    "x   x  xxxxx xxxxx   x x   x",
    "x   x                x x   x",
    "x   x                  x   x",
    "x   xxxxxxxxxxxxxxxxxxxx   x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx"},

    PushButtonPic = {    
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx",    
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x       xxxxxxxxxxx        x",
    "x      x           x       x",
    "x     x             x      x",
    "x     x             xx     x",
    "x     x             xx     x",
    "x     x             xx     x",
    "x     x             xx     x",
    "x     x             xx     x",
    "x     x             xx     x",
    "x      x           xxx     x",
    "x       xxxxxxxxxxxxx      x",
    "x        xxxxxxxxxxx       x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx"},

    RadioButtonPic = {    
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx",    
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x          xxxxx           x",
    "x        xx     xx         x",
    "x       x         x        x",
    "x      x           x       x",
    "x      x    xxx    x       x",
    "x     x    xxxxx    x      x",
    "x     x   xxxxxxx   x      x",
    "x     x   xxxxxxx   x      x",
    "x     x   xxxxxxx   x      x",
    "x     x    xxxxx    x      x",
    "x      x    xxx    x       x",
    "x      x           x       x",
    "x       x         x        x",
    "x        xx     xx         x",
    "x          xxxxx           x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx"},

    ListPic = {    
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x   xxxxxxxxxxxxxxxxxxx    x",
    "x   x           x     x    x",
    "x   x           x  x  x    x",
    "x   x xxxxxxx   x xxx x    x",
    "x   x           x     x    x",
    "x   x           x     x    x",
    "x   x xxxxxxxxx xxxxxxx    x",
    "x   x           x     x    x",
    "x   x           x     x    x",
    "x   x xxxxxxxx  x xxx x    x",
    "x   x           x  x  x    x",
    "x   x           x     x    x",
    "x   xxxxxxxxxxxxxxxxxxx    x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "x                          x",
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx"},

    VScrollPic = {    
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx",
    "x                          x",
    "x                          x",
    "x       xxxxxxxxxxx        x",
    "x       x         x        x",
    "x       x         x        x",
    "x       x    x    x        x",
    "x       x   xxx   x        x",
    "x       x  xxxxx  x        x",
    "x       x   xxx   x        x",
    "x       x   xxx   x        x",
    "x       x         x        x",
    "x       x         x        x",
    "x       xxxxxxxxxxx        x",
    "x       x         x        x",
    "x       x         x        x",
    "x       x   xxx   x        x",
    "x       x   xxx   x        x",
    "x       x  xxxxx  x        x",
    "x       x   xxx   x        x",
    "x       x    x    x        x",
    "x       x         x        x",
    "x       x         x        x",
    "x       xxxxxxxxxxx        x",
    "x                          x",
    "x                          x",
    "x                          x",
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxx"}


-------------------------------------------------------------------------------
function invert( sequence s )
    -- change 'x' to ' ' and ' ' to 'x' in text image
    -- leaves frame alone
    
    for y = 2 to length( s )-1 do
        for x = 2 to length( s[y] )-1 do
            if s[y][x] = 'x' then
                s[y][x] = ' '
            else
                s[y][x] = 'x'
            end if
        end for
    end for
    return s
end function




-------------------------------------------------------------------------------
-- unselected images
constant
    PointerUp       = textToBitmap( PointerPic      ),
    PictureUp       = textToBitmap( PicturePic      ),
    StaticTextUp    = textToBitmap( StaticTextPic   ),
    EditTextUp      = textToBitmap( EditTextPic     ),
    FrameUp         = textToBitmap( FramePic        ),
    PushButtonUp    = textToBitmap( PushButtonPic   ),
    CheckBoxUp      = textToBitmap( CheckBoxPic     ),
    RadioButtonUp   = textToBitmap( RadioButtonPic  ),
    ComboBoxUp      = textToBitmap( ComboBoxPic     ),
    ListUp          = textToBitmap( ListPic         ),
    HScrollUp       = textToBitmap( HScrollPic      ),
    VScrollUp       = textToBitmap( VScrollPic      )
    
-- selected images
constant
    PointerDown     = textToBitmap( invert( PointerPic      ) ),
    PictureDown     = textToBitmap( invert( PicturePic      ) ),
    StaticTextDown  = textToBitmap( invert( StaticTextPic   ) ),
    EditTextDown    = textToBitmap( invert( EditTextPic     ) ),
    FrameDown       = textToBitmap( invert( FramePic        ) ),
    PushButtonDown  = textToBitmap( invert( PushButtonPic   ) ),
    CheckBoxDown    = textToBitmap( invert( CheckBoxPic     ) ),
    RadioButtonDown = textToBitmap( invert( RadioButtonPic  ) ),
    ComboBoxDown    = textToBitmap( invert( ComboBoxPic     ) ),
    ListDown        = textToBitmap( invert( ListPic         ) ),
    HScrollDown     = textToBitmap( invert( HScrollPic      ) ),
    VScrollDown     = textToBitmap( invert( VScrollPic      ) )
    
    
-------------------------------------------------------------------------------
-- assign bitmaps
setBitmap( ThePointer,      PointerDown     )
setBitmap( ThePicture,      PictureUp       )
setBitmap( TheStaticText,   StaticTextUp    )
setBitmap( TheEditText,     EditTextUp      )
setBitmap( TheFrame,        FrameUp         )
setBitmap( ThePushButton,   PushButtonUp    )
setBitmap( TheCheckBox,     CheckBoxUp      )
setBitmap( TheRadioButton,  RadioButtonUp   )
setBitmap( TheComboBox,     ComboBoxUp      )
setBitmap( TheList,         ListUp          )
setBitmap( TheHScroll,      HScrollUp       )
setBitmap( TheVScroll,      VScrollUp       )


-------------------------------------------------------------------------------
-- which item is selected?
integer pressed
    pressed = ThePointer


-- new controls
sequence newControls

    newControls = {}

-------------------------------------------------------------------------------
-- Control Palette Actions

-- the indexes
constant
    ControlID   = 1,    -- the id of the control
    ControlUp   = 2,    -- bitmap of control up
    ControlDown = 3     -- bitmap of control down

-- the controls
constant
    ControlList = { 
        { ThePointer,       PointerUp,      PointerDown     },
        { ThePicture,       PictureUp,      PictureDown     },
        { TheStaticText,    StaticTextUp,   StaticTextDown  },
        { TheEditText,      EditTextUp,     EditTextDown    },
        { TheFrame,         FrameUp,        FrameDown       },
        { ThePushButton,    PushButtonUp,   PushButtonDown  },
        { TheCheckBox,      CheckBoxUp,     CheckBoxDown    },
        { TheRadioButton,   RadioButtonUp,  RadioButtonDown },
        { TheComboBox,      ComboBoxUp,     ComboBoxDown    },
        { TheList,          ListUp,         ListDown        },
        { TheHScroll,       HScrollUp,      HScrollDown     },
        { TheVScroll,       VScrollUp,      VScrollDown     }}

-------------------------------------------------------------------------------
procedure toggleControl( integer id, integer flag )
    -- toggle a control selection on or off
    
    -- look for the control in the list
    for i = 1 to length( ControlList ) do        
        -- found it?
        if ControlList[i][ControlID] = id then
            -- how to set?
            if flag then
                -- display with bitmap down
                setBitmap( id, ControlList[i][ControlDown] )
            else
                -- display with bitmap up
                setBitmap( id, ControlList[i][ControlUp] )
            end if
            -- done
            return            
        end if
    end for
end procedure
                    

-------------------------------------------------------------------------------
procedure onMouse_Controls( integer event, integer x, integer y )

    -- find hit control, and toggle it on            
    
    integer control
    sequence rect

    if event = LEFT_DOWN then
    
        -- check the controls for a hit
        for i = 1 to length( ControlList ) do
        
            -- get the control id
            control = ControlList[i][ControlID]
    
            -- get the size of the control
            rect = getWindowSize( control )
    
            -- true if it falls in the boundaries    
            if  x >= rect[1] and y >= rect[2]
            and x <= rect[3] and y <= rect[4] then
    
                -- toggle prior off
                toggleControl( pressed, 0 )
    
                -- save new pointer
                pressed = control
        
                -- toggle new control on
                toggleControl( pressed, 1 )
    
                -- leave loop
                exit                
                
            end if
        end for

    end if

end procedure

onMouse[Controls] = routine_id("onMouse_Controls")
    


-------------------------------------------------------------------------------
procedure togglePointer()
    -- turn on the pointer, and off any prior controls
        
    -- toggle prior off
    toggleControl( pressed, 0 )

    -- pointer is new selection
    pressed = ThePointer
    
    -- toggle pointer on
    toggleControl( pressed, 1 )
    
end procedure




-------------------------------------------------------------------------------
-- Attribute Box Actions
-- Currently, the attribute box is just a dummy routine.

-------------------------------------------------------------------------------
procedure onMouse_NewControl( integer event, integer x, integer y )
    -- handle mouse events on new controls
    if event = RIGHT_DOWN then
        -- display dialog box with attributes
        openModal( AttribBox )        
    end if
end procedure

-------------------------------------------------------------------------------
procedure onClick_Ok()
    -- close the modal window
    closeWindow( AttribBox )
end procedure

onClick[Ok] =   routine_id("onClick_Ok")


-------------------------------------------------------------------------------
-- Design Window Actions



-------------------------------------------------------------------------------
procedure onMouse_Design( integer event, integer x, integer y )

    -- handles mouse clicks in design window
    -- left click:  if control type is selected, place in window
    -- right click: if on control, display attributes
    
    integer control, x2, y2
    atom newID
    sequence text, rect

    if event = LEFT_DOWN then
          
        -- create a control where the mouse clicked,
        -- using the control type selected in the controls palette
          
        if pressed = ThePicture then    
            -- bitmap control
            control = Bitmap
            text = "Bitmap"
            x2 = 100
            y2 = 150
            
        elsif pressed = TheStaticText then
            -- static text
            control = LText
            text = "Static Text"
            x2 = 150
            y2 = 20
            
        elsif pressed = TheEditText then
            -- edit text
            control = EditText
            text = "Edit Text"
            x2 = 150
            y2 = 20
        
        elsif pressed = TheFrame then
            -- group
            control = Group
            text = "Frame"
            x2 = 150
            y2 = 60
        
        elsif pressed = ThePushButton then
            -- push button
            control = PushButton
            text = "Push Button"
            x2 = 80
            y2 = 20
     
        elsif pressed = TheCheckBox then
            -- check box
            control = CheckBox
            text = "CheckBox"
            x2 = 150
            y2 = 20
    
        elsif pressed = TheRadioButton then
            -- radion button
            control = Radio
            text = "Radio Button"
            x2 = 150
            y2 = 20
    
        elsif pressed = TheComboBox then
            -- combo box
            control = Combo
            text = "Combo Box"
            x2 = 150
            y2 = 20
    
        elsif pressed = TheList then
            -- list
            control = List
            text = "List"
            x2 = 150
            y2 = 120
    
        elsif pressed = TheHScroll then
            -- horizontal scroll bar
            control = HScroll
            text = "HScroll"
            x2 = 150
            y2 = 20
    
        elsif pressed = TheVScroll then
            -- vertical scroll bar
            control = VScroll
            text = "VScroll"
            x2 = 20
            y2 = 150
    
        else
            -- no control
            control = 0
     
        end if
    
        -- create a control?
        if control then
    
            -- create the control
            newID = create( control, text, Design, x, y, x2, y2, 0 )
    
            -- save values
            newControls = append( newControls, newID )
              
            -- assign behavior
            onMouse[newID] = routine_id("onMouse_NewControl")
            
            -- click the pointer
            togglePointer()
              
        end if

    elsif event = RIGHT_DOWN then
          
        -- Determines what control was right clicked, and pops up
        -- the dialog showing the information about that control.
        -- This catches right clicks on static controls that don't
        -- handle the event.
          
        -- check the controls for a hit
        for i = 1 to length( newControls ) do
        
            -- get the control id
            control = newControls[i]
    
            -- get the size of the control
            rect = getWindowSize( control )
    
            -- true if it falls in the boundaries    
            if  x >= rect[1] and y >= rect[2]
            and x <= rect[3] and y <= rect[4] then
            
                -- popup attributes
                onMouse_NewControl( RIGHT_DOWN, x, y )
                
            end if
        end for
        
    end if
end procedure

onMouse[Design] = routine_id("onMouse_Design")





-------------------------------------------------------------------------------
procedure onOpen_Design()

    -- open the secondary window
    
    -- load the control window
    openWindow( Controls )
    
    -- focus back on main window
    setFocus( Design )   
    
    
end procedure

onOpen[Design] = routine_id("onOpen_Design")
    

-------------------------------------------------------------------------------
-- default button
WinMain( Design )

