-- example8.exw
--
-- This example places a menu in a window

include dos32lib.e
without warning

constant MenuWin = 
    create( Window, "Menus", 0, Default, Default, 200, 100, 0 )

constant
FileMenu = create( Menu, "&File", MenuWin, 0, 0, 0, 0, 0 ),
    MenuNew     = create( MenuItem, "&New",     FileMenu, 0,0,0,0,0 ),
    MenuOpen    = create( MenuItem, "&Open",    FileMenu, 0,0,0,0,0 ),
    MenuSave    = create( MenuItem, "&Save",    FileMenu, 0,0,0,0,0 ),
    MenuSaveAs  = create( MenuItem, "Save &As", FileMenu, 0,0,0,0,0 ),
    MenuSep1    = create( MenuItem, "-",        FileMenu, 0,0,0,0,0 ),
    MenuExit    = create( MenuItem, "&Exit",    FileMenu, 0,0,0,0,0 ),

EditMenu = create( Menu, "&Edit", MenuWin, 0, 0, 0, 0, 0 ),     
    MenuUndo    = create( MenuItem, "&Undo",    EditMenu, 0,0,0,0,0 ),
    MenuSep2    = create( MenuItem, "-",        EditMenu, 0,0,0,0,0 ),
    MenuCut     = create( MenuItem, "Cu&t",     EditMenu, 0,0,0,0,0 ),
    MenuCopy    = create( MenuItem, "&Copy",    EditMenu, 0,0,0,0,0 ),
    MenuPaste   = create( MenuItem, "&Paste",   EditMenu, 0,0,0,0,0 ),
    MenuDelete  = create( MenuItem, "De&lete",  EditMenu, 0,0,0,0,0 ),
    MenuEdit    = create( MenuItem, "&Edit",    EditMenu, 0,0,0,0,0 ),

HelpMenu = create( Menu, "&Help", MenuWin, 0, 0, 0, 0, 0 ),
    MenuAbout   = create( MenuItem, "&About...\tAlt+A", HelpMenu, 0,0,0,0,0 )
        

-- disable a menu item
setEnable( MenuUndo, 0 )
    

-- default behaviors
procedure menu_item_selected()
    integer result
    
    result = message_box( "Menu Item Selected", "", 0 )
    
end procedure

-- set to default
    onClick[ MenuOpen ]     = routine_id( "menu_item_selected" )
    onClick[ MenuNew ]      = routine_id( "menu_item_selected" )
    onClick[ MenuSave ]     = routine_id( "menu_item_selected" )
    
    onClick[ MenuUndo ]     = routine_id( "menu_item_selected" )
    onClick[ MenuCut ]      = routine_id( "menu_item_selected" )
    onClick[ MenuCopy ]     = routine_id( "menu_item_selected" )
    onClick[ MenuPaste ]    = routine_id( "menu_item_selected" )
    onClick[ MenuDelete ]   = routine_id( "menu_item_selected" )
    onClick[ MenuEdit ]     = routine_id( "menu_item_selected" )

-- about... behavior
procedure onMenu_MenuAbout()
    integer result
    
    result = message_box(   "Win32Lib Menu Demo",               -- text
                            "About This Demo",                  -- title
                            MB_ICONINFORMATION+MB_TASKMODAL )   -- icon
end procedure

onClick[ MenuAbout ] = routine_id( "onMenu_MenuAbout" )


-- exit behavior
procedure onMenu_MenuExit()
    closeWindow( MenuWin )
end procedure

onClick[ MenuExit ] = routine_id( "onMenu_MenuExit" )


WinMain( MenuWin )


