-- example10.exw
--
-- Demonstrate scroll bars

include dos32lib.e
without warning

integer fontSize        -- size of font
    fontSize = 14       -- initialize to 14 points

constant ScrollWin =  
    create( Window, "Scroll Bar", 0, Default, Default, 200, 160, 0 )

-- create a control in the window
constant Scroll = create( HScroll, "OK", ScrollWin, 1, 1, 80, 16, 0 )    

-- scroll action
procedure onScroll_Scroll( integer pos )

    -- save the font size
    fontSize = pos
    
    -- redraw the window
    repaintWindow( ScrollWin )
    
end procedure

-- tell Windows when to do the action
    onScroll[Scroll] = routine_id( "onScroll_Scroll" )
             
             
-- paint action
procedure onPaint_ScrollWin( integer x1, integer y1, integer x2, integer y2 )
             
    setPosition( ScrollWin, 1, 30 )      
    setFont( ScrollWin, "Times New Roman", fontSize, 0 )
    wPrintf( ScrollWin, "%d points", {fontSize} )
    
end procedure
             
-- tell Windows when to do the action
    onPaint[ScrollWin] = routine_id( "onPaint_ScrollWin" )


procedure onOpen_ScrollWin()        
    -- set range of scroll bar
    setScrollRange( Scroll, 1, 100  )

    -- set scroll line/page up/down increments
    setScrollChange( Scroll, 1, 10 )
        
    -- scroll to default font size
    setScrollPos( Scroll, fontSize )
    
end procedure

-- tell Windows when to do the action
    onOpen[ScrollWin] = routine_id( "onOpen_ScrollWin" )
    

WinMain( ScrollWin )


