-- example16.exw
-- Demonstrate 0.13 features:
--
--      Display Bitmaps In Window
--      Change Control's Font

include dos32lib.e
without warning

-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- controls

constant    

-- the window
MyWindow =  
    create( Window, "Test Window", 0, Default, Default, 200, 100, 0 ),

-- create a control in the window
MyButton = 
    create( PushButton, "OK", MyWindow, 10, 10, 80, 40, 0 ),
    
-- load the bitmap
hBitmap = loadBitmapFromFile("tiles.bmp")    

-- change the font
setFont( MyButton, "Times New Roman", 18, Bold+Italic )


-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- actions


-----------------------------------------------------------------------------
procedure onPaint_MyWindow( integer x1, integer y1, integer x2, integer y2 )

    sequence extent
    
    -- get the window size
    extent = getWindowExtent( MyWindow )

    -- fill with the 32x32 bitmap    
    for i = 0 to extent[1] by 32 do
        for j = 0 to extent[2] by 32 do
            drawBitmap( MyWindow, hBitmap, i, j )                
        end for
    end for         
    
end procedure
onPaint[MyWindow] = routine_id("onPaint_MyWindow")    

-- hand control over to Windows
WinMain( MyWindow )

