-- example17.exw
--
-- Demonstrate hand-built bitmaps

include dos32lib.e
without warning

constant Win =  
    create( Window, "Tile Window", 0, Default, Default, 240, 260, 0 )

-- the bitmap tiles
constant Block = textToBitmap( {
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx"} )

constant Question = textToBitmap( {
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxx      xxxxxxx",
    "xxxxxxx         xxxxxx",
    "xxxxxx           xxxxx",
    "xxxxx     xxxx    xxxx",
    "xxxxx    xxxxx    xxxx",
    "xxxxx    xxxxx    xxxx",
    "xxxxxxxxxxxxxx    xxxx",
    "xxxxxxxxxxxxx     xxxx",
    "xxxxxxxxxxxx     xxxxx",
    "xxxxxxxxxxx     xxxxxx",
    "xxxxxxxxxxx    xxxxxxx",
    "xxxxxxxxxx    xxxxxxxx",
    "xxxxxxxxxx    xxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxxxxxxxx    xxxxxxxx",
    "xxxxxxxxxx    xxxxxxxx",
    "xxxxxxxxxx    xxxxxxxx",
    "xxxxxxxxxx    xxxxxxxx",
    "xxxxxxxxxxxxxxxxxxxxxx"} )

constant Check = textToBitmap( {
    "xxxxxxxxxxxxxxxxxxxxxx",
    "xxxx xxxxxxxxxxxx xxxx",
    "xxx   xxxxxxxxxx   xxx",
    "xx     xxxxxxxx     xx",
    "x       xxxxxx       x",
    "xx       xxxx       xx",
    "xxx       xx       xxx",
    "xxxx              xxxx",
    "xxxxx            xxxxx",
    "xxxxxx          xxxxxx",
    "xxxxxxx        xxxxxxx",
    "xxxxxxx        xxxxxxx",
    "xxxxxx          xxxxxx",
    "xxxxx            xxxxx",
    "xxxx              xxxx",
    "xxx       xx       xxx",
    "xx       xxxx       xx",
    "x       xxxxxx       x",
    "xx     xxxxxxxx     xx",
    "xxx   xxxxxxxxxx   xxx",
    "xxxx xxxxxxxxxxxx xxxx",
    "xxxxxxxxxxxxxxxxxxxxxx" } )

constant Mine = textToBitmap( {
    "xx                 xx ",
    "xx                 xx ",
    "  x    xxxxxxx    x   ",
    "   x x     x xxx x    ",
    "    x        x xx     ",
    "   x     x  x xxxx    ",
    "   x      xx x xxx    ",
    "  x  x  x   xxxxxxx   ",
    "  xx     x x x xxxx   ",
    "  x  x x  x xxxxxxx   ",
    "  xxx x xx xxxxxxxx   ",
    "  xxx x  xxxxxxxxxx   ",
    "  x x xxx xxxxxxxxx   ",
    "  xxxx xxxxxxxxxxxx   ",
    "   x xxxxxxxxxxxxx    ",
    "   xxxxxxxxxxxxxxx    ",
    "    xxxxxxxxxxxxx     ",
    "   x xxxxxxxxxxx x    ",
    "  x    xxxxxxx    x   ",
    "xx                 xx ",
    "xx                 xx ",
    "                      " } )        

   
function pick( sequence s )    
    -- return a random item from the sequence
    return s[ rand(length(s)) ]
end function


procedure Paint( integer x1, integer y1, integer x2, integer y2 )
    -- tile the bitmaps randomly across the window
    
    atom bmp

    sequence extent
    
    -- get the window size
    extent = getWindowExtent( Win )

    -- fill with the 32x32 bitmap    
    for i = 0 to extent[1] by 23 do
        for j = 0 to extent[2] by 23 do
    
            -- pick a random bitmap
            bmp = pick( {Block,Question,Check,Mine} )
    
            -- draw it
            drawBitmap( Win, bmp, i, j )
    
        end for
    end for         
end procedure
onPaint[Win] = routine_id("Paint")

WinMain( Win )


